// Copyright (c) 2015, the Dogma Project Authors.
// Please see the AUTHORS file for details. All rights reserved.
// Use of this source code is governed by a zlib license that can be found in
// the LICENSE file.

/// Contains the default paths for the generated libraries.
library dogma_codegen.src.build.default_paths;

//---------------------------------------------------------------------
// Library contents
//---------------------------------------------------------------------

/// The default path to the root model library.
const String defaultModelLibrary = 'lib/models.dart';
/// The default path to the directory where the model libraries will be
/// present.
const String defaultModelPath = 'lib/src/models';

/// The default path to the root unmodifiable views library.
const String defaultUnmodifiableLibrary = 'lib/unmodifiable_model_views.dart';
/// The default path to the directory where the unmodifiable views libraries
/// will be present.
const String defaultUnmodifiablePath = 'lib/src/unmodifiable_model_views';

/// The default path to the root converter library.
const String defaultConvertLibrary = 'lib/convert.dart';
/// The default path to the directory where the convert libraries will be
/// present.
const String defaultConvertPath = 'lib/src/convert';

/// The default path to the mapper library.
const String defaultMapperLibrary = 'lib/mapper.dart';
/// The default path to the directory where the mapper libraries will be
/// present.
const String defaultMapperPath = 'lib/src/mapper';
